// Fichier des Animations du KaTZ-Pit

// Pour chaque cadran, la rotation est géré 
// avec un parametre origine (position aiguille à zero)
// et gain (conversion unité / degré de rotation) 


// Rotation des aiguilles moteurs (left, right)
function Rotate_RPM(l,r){
	var a_origine = 44
	var a_gain = 3.16

	$("#AM_RPM_L").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*l)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*l)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*l)+'deg)',
	})

	$("#AM_RPM_R").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*r)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*r)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*r)+'deg)',


	})
}

// Rotation des flèches et rosace du HSI (Cap,WayPoint,Route)
function Rotate_HSI(cap,way,route,tgt){
	var a_origine = 0
	var a_gain = 1
	
	$("#AN_Rosace").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*cap)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*cap)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*cap)+'deg)',
	})

	$("#AN_Way").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*way)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*way)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*way)+'deg)',
	})

	$("#AN_Route").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*route)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*route)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*route)+'deg)',
	})

	$("#AN_TgT").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*tgt)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*tgt)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*tgt)+'deg)',
	})

}


// Aiguilles du G-mètre avec (valeur,min,max)
function Rotate_G(val,min,max){
	var a_origine = 127
	var a_gain = -10
	
	$("#AA_G").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
	})

	$("#AA_Gmin").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*min)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*min)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*min)+'deg)',
	})

	$("#AA_Gmax").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*max)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*max)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*max)+'deg)',
	})
}

// Aiguille de l'indicateur d'AoA (valeur)
function Rotate_AoA(val){
	var a_origine = 218
	var a_gain = 3.4
	
	$("#AA_AoA").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
	})
}

// Silhouette de l'indicateur de roulis (valeur)
function Rotate_Bank(val){
	var a_origine = 0
	var a_gain = 1

	$("#AA_Bank").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
	})

	$("#IA_Bank").css({
		'-moz-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-webkit-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
		'-ms-transform':'rotate('+(a_origine+a_gain*val)+'deg)',
	})
}

// Translation Yaw indicateur (valeur)
// 34px pour 10 °/mn
function Translate_Yaw(val){
	var a_origine = 0
	var a_gain = 3.4
	
	$("#AA_Yaw").css({

	// fonction de base >> '-moz-transform':'translate(100px,0px)',
	'-moz-transform':'translate('+(a_origine + a_gain * val)+'px,0px)',
	'-webkit-transform':'translate('+(a_origine + a_gain * val)+'px,0px)',
	'-ms-transform':'translate('+(a_origine + a_gain * val)+'px,0px)',

	})
}

// Translation ILS Up/Down
function Translate_ILS(valup, valat){
	var a_origine = 0
	var a_gain = 0.75



	// valup : positif = Translation vers le bas , changement du signe DCS
	$("#IA_Up").css({
	'-moz-transform':'translate(0px,'+(a_origine - a_gain * valup)+'px)',
	'-webkit-transform':'translate(0px,'+(a_origine - a_gain * valup)+'px)',
	'-ms-transform':'translate(0px,'+(a_origine - a_gain * valup)+'px)',
	})

	// valat : positif = Translation vers la droite
	$("#IA_Lat").css({
	'-moz-transform':'translate('+(a_origine + a_gain * valat)+'px,0px)',
	'-webkit-transform':'translate('+(a_origine + a_gain * valat)+'px,0px)',
	'-ms-transform':'translate('+(a_origine + a_gain * valat)+'px,0px)',
	})

}

// Jauge Carburant
function Jauge_Fuel(pct_i, pct_e){
	var a_origine = 0
	var a_gain = 5

	// On fixe l'origine du "scale down" en bas
	$("#FA_Gauge_Main").css({
	'-moz-transform-origin':'bottom left',
	'-webkit-transform-origin':'bottom left',
	'-ms-transform-origin':'bottom left',
	})

	// Scale down %age restant = hauteur barre orange
	$("#FA_Gauge_Main").css({
	'-moz-transform':'scaleY('+pct_i+')',
	'-webkit-transform':'scaleY('+pct_i+')',
	'-ms-transform':'scaleY('+pct_i+')',
	})

	// On fixe l'origine du "scale down" en bas
	$("#FA_Gauge_Tank").css({
	'-moz-transform-origin':'bottom left',
	'-webkit-transform-origin':'bottom left',
	'-ms-transform-origin':'bottom left',
	})

	// Scale down %age restant = hauteur barre orange
	$("#FA_Gauge_Tank").css({
	'-moz-transform':'scaleY('+pct_e+')',
	'-webkit-transform':'scaleY('+pct_e+')',
	'-ms-transform':'scaleY('+pct_e+')',
	})

}


// Fonction principale de gestion des animations du KaTZ-Pit
function panelanim_update(KaTZPit_data){

	// Pour une question de clareté les valeurs de rotation sont calculées (i_xxxx)
	// Il sera possible d'envoyer directement les valeurs de la base de données au fonctions

	// --------------------------------------------------------------------
	// Panel Moteur
	// Rotation Aiguilles Moteur (origine et gain dans les fonctions
	Rotate_RPM((KaTZPit_data["RPM_L"]), (KaTZPit_data["RPM_R"]));

	
	// --------------------------------------------------------------------
	// Panel Fuel	
	// Calcul du %age de remplissage des réservoirs Fuel Interne / Externe
	// En fonction des données de spec. avion
	var i_Fuel_ipct = KaTZPit_data["Fuel_i"] / Plane_data["Fuel_imax"]
	var i_Fuel_epct = KaTZPit_data["Fuel_e"] / Plane_data["Fuel_emax"]

	Jauge_Fuel(i_Fuel_ipct,i_Fuel_epct)

	// --------------------------------------------------------------------
	// Panel Attitude

	// Test de comparaison G-Actuel avec G-min et G-max	 
	var i_Gmax = Math.max(KaTZPit_data["Acc_Gmax"],KaTZPit_data["Acc_G"])
	var i_Gmin = Math.min(KaTZPit_data["Acc_Gmin"],KaTZPit_data["Acc_G"])

	// Mise à jour des valeurs G-min et G-Max dans la base de données
	KaTZPit_data["Acc_Gmax"] = i_Gmax
	KaTZPit_data["Acc_Gmin"] = i_Gmin
	
	Rotate_G(KaTZPit_data["Acc_G"],i_Gmin,i_Gmax)
	Rotate_AoA(KaTZPit_data["AoA"])

	Translate_Yaw(KaTZPit_data["Yaw"])
	Rotate_Bank(KaTZPit_data["Bank"])

	// --------------------------------------------------------------------
	// Panel Navigation
	var i_Cap = 360 - KaTZPit_data["Cap"]
	var i_Way = (KaTZPit_data["Way"] + i_Cap) % 360
	var i_Route = (KaTZPit_data["Route"] + i_Cap) % 360


	if (KaTZPit_data["TGT_select"] == 1) {i_tgt = KaTZPit_data["T1_deg"]} 
	if (KaTZPit_data["TGT_select"] == 2) {i_tgt = KaTZPit_data["T2_deg"]} 
	if (KaTZPit_data["TGT_select"] == 3) {i_tgt = KaTZPit_data["T3_deg"]} 
	
	var i_tgt = (i_tgt + i_Cap) % 360


	// Rotation Aiguilles HSI
	Rotate_HSI(i_Cap, i_Way, i_Route,i_tgt)
	
	// --------------------------------------------------------------------
	// Panel ILS
	// Croix ILS Up/Down et Latérale
	Translate_ILS(KaTZPit_data["ILS_up"],KaTZPit_data["ILS_lat"])

	// Silouette Bank (idem Bank Indicator)

}